import { Cache } from '@ztimson/utils';
import { Api } from './api';
import { Meta, Notification } from './core';
import { PathedEventEmitter } from './pathed-events';
export type Group = Meta & {
    name: string;
    description?: string;
    notes?: string;
    users: string[];
    notifications: Notification[];
    permissions: string[];
    custom: any;
};
export declare class Groups extends PathedEventEmitter {
    private readonly api;
    cache: Cache<string, Group>;
    constructor(api: Api | string);
    all(reload?: boolean): Promise<Group[]>;
    create(group: Group): Promise<Group>;
    read(name: string, reload?: boolean): Promise<Group>;
    update(group: Group): Promise<Group>;
    delete(name: string): Promise<void>;
}
//# sourceMappingURL=groups.d.ts.map